unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics,
  Controls, Forms, Dialogs, uniGUITypes, uniGUIAbstractClasses,
  uniGUIClasses, uniGUIRegClasses, uniGUIForm, uniCanvas, uniGUIBaseClasses, uniButton,
  Unit_Captcha, uniLabel, uniEdit, uniCheckBox, uniSpinEdit, uniPanel, uniPageControl, uniBasicGrid, uniDBGrid, IdCoder,
  IdCoder3to4, IdCoder00E, IdCoderXXE, IdBaseComponent, uniMemo, IdComponent, IdTCPConnection, IdTCPClient,
  IdHTTP,IdContext,IdCustomTCPServer,IdCustomHTTPServer ;

type
  TfEncryptLinkApp = class(TUniForm)
    UniPageControl1: TUniPageControl;
    tsEncryptLink: TUniTabSheet;
    tsAllEncryptedLinks: TUniTabSheet;
    eEncryptedLink: TUniEdit;
    lEcryptedLink: TUniLabel;
    bEncryptLink: TUniButton;
    cbUseNoBlockMe: TUniCheckBox;
    cbTimeLimitation: TUniCheckBox;
    seTimeLimitation: TUniSpinEdit;
    eOriginLink: TUniEdit;
    lOriginLink: TUniLabel;
    pTop: TUniPanel;
    UniDBGrid1: TUniDBGrid;
    IdEncoderXXE: TIdEncoderXXE;
    IdDecoderXXE: TIdDecoderXXE;
    IdHTTP: TIdHTTP;
    bTest: TUniButton;
    procedure bEncryptLinkClick(Sender: TObject);
    procedure UniFormShow(Sender: TObject);
    procedure bTestClick(Sender: TObject);
  private
    procedure IdHTTPServerCommandGet(AContext: TIdContext; ARequestInfo: TIdHTTPRequestInfo;
      AResponseInfo: TIdHTTPResponseInfo);
    { Private declarations }
  public
    { Public declarations }


   procedure Redirect(URL:string);

  end;

function fEncryptLinkApp: TfEncryptLinkApp;

implementation

{$R *.dfm}

uses
  uniGUIVars, MainModule, uniGUIApplication;



function fEncryptLinkApp: TfEncryptLinkApp;
begin
  Result := TfEncryptLinkApp(UniMainModule.GetFormInstance(TfEncryptLinkApp));
end;

procedure TfEncryptLinkApp.bEncryptLinkClick(Sender: TObject);

var
    OriginLink:string;

    NoBlockMeParam:string;
    EncryptedNoBlockMeParam:string;

    TimeLimitParam:string;
    EncryptedTimeLimitParam:string;

    ParamsToAdd:string;
    ParamsThatWereInLink: string;

    SplittedArrayAmpersand:TArray<string>;
    SplittedArrayEqual:TArray<string>;

    Position:integer;
    i: Integer;
    s: string;
    DecryptedValue: string;
  OriginLinkLowered: string;
  StartDateTimeParam: string;

  IsExitFromHere:boolean;
  OriginLinkParam: string;

begin



//-----------------------------1 STEP Checks


   //
     eEncryptedLink.Text:='';
     eEncryptedLink.Clear;

     OriginLink:=( (eOriginLink.Text) );


     // Check if params already there...

     if OriginLink.Contains('?') then

        begin


        Position:=Pos('?',OriginLink);

        ParamsThatWereInLink:=OriginLink.Substring(Position);

        ShowMessage(ParamsThatWereInLink);

        SplittedArrayAmpersand:=ParamsThatWereInLink.Split(['&']);


        for i := Low(SplittedArrayAmpersand) to High(SplittedArrayAmpersand) do
         begin


         //

         if ( SplittedArrayAmpersand[i].Contains('noblockmeparam') )
         or ( SplittedArrayAmpersand[i].Contains('timelimitparam') )
         or ( SplittedArrayAmpersand[i].Contains('startdatetimeparam'))

         then

          begin
            IsExitFromHere:=true;

            ShowMessage('Clear Link from NoBlockMeParam or TimeLimitParam or both');
            Break;


          end;


         // if Params were Encrypted
         //DecryptedValue:=IdDecoderXXE.DecodeString(SplittedArrayAmpersand[i]);


             // dividing noblockmeparam=somevalue on [noblockmeparam,somevalue]

         SplittedArrayEqual:=SplittedArrayAmpersand[i].Split(['=']);


         if Length(SplittedArrayEqual)>0 then

           begin


            DecryptedValue:=IdDecoderXXE.DecodeString( SplittedArrayEqual[0] );


             if (DecryptedValue.Contains('noblockmeparam'))
             or (DecryptedValue.Contains('timelimitparam'))
             or (DecryptedValue.Contains('startdatetimeparam'))

             then begin

               IsExitFromHere:=true;

               eEncryptedLink.Text:='';
               eEncryptedLink.Clear;

               ShowMessage('Clear Link from Encrypted NoBlockMeParam or TimeLimitParam or both'+
               #13#10+'just delete all encrypted symbols after ? sign');
               Break;
              // Exit;

             end;






           end;



         end;


        end;


if IsExitFromHere then Exit;


    // To not to Destroy Ecryption lets lower case here, after decrypt !

      OriginLinkLowered:=AnsiLowerCase( (eOriginLink.Text) );




        //Does it contain http:// or https:// ?

        if not (OriginLinkLowered.Contains('http://'))
        and not (OriginLinkLowered.Contains('https://'))
        then

           begin
          ShowMessage('Give Link with http:// or https://');
          exit;
          end;


              // Is Emty Origin Link ?
              if OriginLinkLowered.IsEmpty then

              begin
              ShowMessage('Origin Link is Empty');
              exit;
              end;





//---------------------------------------ADDING PARAMS--------------------


//Adding  OriginLinkParam


OriginLinkParam:=
IdEncoderXXE.Encode('originlinkparam')+
   '='+
   IdEncoderXXE.Encode(OriginLink);

ParamsToAdd:=ParamsToAdd+OriginLinkParam;


//Adding  TimeLimitParam

if cbTimeLimitation.Checked=true then
   begin


   StartDateTimeParam:=
   IdEncoderXXE.Encode('startdatetimeparam')+
   '='+
   IdEncoderXXE.Encode(DateTimeTostr(Now));


   TimeLimitParam:=
   IdEncoderXXE.Encode('timelimitparam')+
   '='+
   IdEncoderXXE.Encode(seTimeLimitation.Value.ToString());


   ParamsToAdd:=ParamsToAdd+'&'+StartDateTimeParam+'&'+TimeLimitParam;
   end;


          if cbUseNoBlockMe.Checked=true then

            begin

               NoBlockMeParam:=
               IdEncoderXXE.Encode('noblockmeparam')+
               '='+
               IdEncoderXXE.Encode('true');


            //NoBlockMeParam:=IdEncoderXXE.Encode(NoBlockMeParam);
            ParamsToAdd:=ParamsToAdd+'&'+NoBlockMeParam
            end;




            { // Previous Variant

               //Adding ParamsToAdd to OriginLink

               if ( OriginLink.Contains('?') )

               // and last symbol<>?
               and ( ( OriginLink.Substring(OriginLink.Length-1)<>('?') ))

               then
                OriginLink:=OriginLink+'&'+ParamsToAdd


                else

                      if  ( OriginLink.Contains('?') )

                     // and last symbol=?
                     and ( ( OriginLink.Substring(OriginLink.Length-1)=('?') ))

                     then OriginLink:=OriginLink+ParamsToAdd

                    else

                        OriginLink:=OriginLink+'?'+ParamsToAdd;

           }

           //   ShowMessage(UniSession.URL);




  //  eEncryptedLink.Text:=OriginLink;

        if ParamsThatWereInLink<>'' then
        eEncryptedLink.Text:=UniSession.URL+'?'+ParamsThatWereInLink+'&'+ParamsToAdd else
        eEncryptedLink.Text:=UniSession.URL+'?'+ParamsToAdd



end;

procedure TfEncryptLinkApp.UniFormShow(Sender: TObject);

var noblockmeparam,timelimitparam,startdatetimeparam:string;
    StartDateTime: TDateTime;
    StartDateTimeString: string;
    TimeLimit: Int64;


begin

//




  {

    noblockmeparam:='noblockmeparam';
    timelimitparam:='timelimitparam';
    startdatetimeparam:='startdatetimeparam';

    noblockmeparam:=IdEncoderXXE.Encode(noblockmeparam);
    timelimitparam:=IdEncoderXXE.Encode(timelimitparam);
    startdatetimeparam:=IdEncoderXXE.Encode(startdatetimeparam);


    ShowMessage(


          IdDecoderXXE.DecodeString(

          UniApplication.Parameters.Values[startdatetimeparam]

          )



    );

  }

end;







procedure TfEncryptLinkApp.bTestClick(Sender: TObject);
begin

UniSession.UrlRedirect('http://digital-flame.ru/');

end;

procedure TfEncryptLinkApp.IdHTTPServerCommandGet(AContext: TIdContext;
  ARequestInfo: TIdHTTPRequestInfo; AResponseInfo: TIdHTTPResponseInfo);
begin



{
//ARequestInfo.Params

UniMemo2.Lines.Clear;
UniMemo2.Lines.Text:=ARequestInfo.Params.Values['name'];// ARequestInfo.Params.Text;

if ARequestInfo.Params.Values['MyComand']='DoSomethingNow' then
ShowMessage('ComandReceived');
}


end;




procedure TfEncryptLinkApp.Redirect(URL: string);
begin


UniSession.UrlRedirect(URL);

end;

initialization
  RegisterAppFormClass(TfEncryptLinkApp);

end.
