unit uHelloForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics,
  Controls, Forms, Dialogs, uniGUITypes, uniGUIAbstractClasses,
  uniGUIClasses, uniGUIForm, uniGUIBaseClasses, uniButton, IdBaseComponent, IdCoder, IdCoder3to4, IdCoder00E, IdCoderXXE,
  uniLabel,System.DateUtils,System.JSON, IdComponent, IdTCPConnection, IdTCPClient, IdHTTP;

type
  TfHelloForm = class(TUniForm)
    bClose: TUniButton;
    IdEncoderXXE: TIdEncoderXXE;
    tWelcome: TUniLabel;
    IdDecoderXXE: TIdDecoderXXE;
    lStatus: TUniLabel;
    IdHTTP: TIdHTTP;
    procedure bCloseClick(Sender: TObject);
    procedure UniFormShow(Sender: TObject);

    procedure UniFormAfterShow(Sender: TObject);
  private
    { Private declarations }

    FOriginLink:string;

    function AnonymizeLink(URL_Origin:string):string;

  public
    { Public declarations }
  end;

function fHelloForm: TfHelloForm;

implementation

{$R *.dfm}

uses
  MainModule, uniGUIApplication,Main;

function fHelloForm: TfHelloForm;
begin
  Result := TfHelloForm(UniMainModule.GetFormInstance(TfHelloForm));
end;




function TfHelloForm.AnonymizeLink(URL_Origin: string): string;

var ServerAnswer:string;
    JSONObject:TJSONObject;
    ErrorCode:string;
    i: Integer;

begin

if URL_Origin='' then Exit;


    ServerAnswer:=IdHTTP.Get(

    // example  'http://noblockme.ru/api/anonymize?url=http://ru.wikipedia.org/'

    'http://noblockme.ru/api/anonymize?url='+FOriginLink


    );


    JSONObject:=TJSONObject.ParseJSONValue(ServerAnswer) as TJSONObject;



      //Looking for error if it is

                       for i := 0 to JSONObject.Count-1 do
                    begin


                         begin

                    if JSONObject.Pairs[i].JsonString.Value='error' then
                     begin

                     if JSONObject.Pairs[i].JsonValue.Value<>'0' then

                       begin
                       ErrorCode:=JSONObject.Pairs[i].JsonValue.Value;

                       end;


                     end;


                    end;

                    end;





      // Looking for Answer status in Json Object

                    for i := 0 to JSONObject.Count-1 do
                    begin

                    if JSONObject.Pairs[i].JsonString.Value='status' then
                     begin

                     if JSONObject.Pairs[i].JsonValue.Value<>'0' then

                       begin
                       Result:='Some Error on Anonymizing Server ErrorCode='+ErrorCode;

                       end;


                     end;


                    end;


                    //if No Errors...

                    if ErrorCode='' then begin

                           for i := 0 to JSONObject.Count-1 do
                        begin

                        if JSONObject.Pairs[i].JsonString.Value='result' then
                         begin

                           Result:=JSONObject.Pairs[i].JsonValue.Value;


                         end;


                        end;


                    end;



end;

procedure TfHelloForm.bCloseClick(Sender: TObject);
begin

ShowMessage('Good Bye, Friend');
Close;
UniApplication.Terminate('Session Terminated');

end;






procedure TfHelloForm.UniFormShow(Sender: TObject);
begin

//UniSession.UrlRedirect(FOriginLink); // doesn't redirect

end;



procedure TfHelloForm.UniFormAfterShow(Sender: TObject);

var noblockmeparam,timelimitparam,
    startdatetimeparam,originlinkparam:string;
    HoursLimit:integer;
    Startdatetime:TDateTime;
  AnonymizedLink: string;
   // OriginLink:string;

begin


 // In Encrypted Link we have encoded param names, so we should repeat it here
 // to parse them in the link

    noblockmeparam:='noblockmeparam';
    timelimitparam:='timelimitparam';
    startdatetimeparam:='startdatetimeparam';
    originlinkparam:='originlinkparam';

    noblockmeparam:=IdEncoderXXE.Encode(noblockmeparam);
    timelimitparam:=IdEncoderXXE.Encode(timelimitparam);
    startdatetimeparam:=IdEncoderXXE.Encode(startdatetimeparam);
    originlinkparam:=IdEncoderXXE.Encode(originlinkparam);


// if noblockmeparam in params...
if UniApplication.Parameters.Values[noblockmeparam]=IdEncoderXXE.Encode('true')

then begin


    //Getting Origin Link

    FOriginLink:=


             IdDecoderXXE.DecodeString(
              UniApplication.Parameters.Values[originlinkparam]
              );

     AnonymizedLink:=AnonymizeLink(FOriginLink);


     //----------Check if Link Expired

   //    ShowMessage(OriginLink);


   if UniApplication.Parameters.Values[timelimitparam]<>'' then

       HoursLimit:=

              IdDecoderXXE.DecodeString(
              UniApplication.Parameters.Values[timelimitparam]
              ).ToInteger;



   if UniApplication.Parameters.Values[startdatetimeparam]<>'' then

       Startdatetime:=

             StrTodateTime(

              IdDecoderXXE.DecodeString(
              UniApplication.Parameters.Values[startdatetimeparam]
              )
             );


 //-----------------Check  Time Expired

 if  ( UniApplication.Parameters.Values[startdatetimeparam]<>'' )
 and (UniApplication.Parameters.Values[timelimitparam]<>'')
 and ((UniApplication.Parameters.Values[originlinkparam]<>''))

 then

        begin


                   if HoursBetween(Now,Startdatetime)>HoursLimit
               then
                   begin


                   lStatus.Caption:='Link Expired';
                   ShowMessage('Link Expired');

                   end else

                   begin

                   lStatus.Caption:='All Ok. Link not Expired. Redirecting';
                   UniSession.UrlRedirect(AnonymizedLink);

                   end;



        end else

        //---if No Check  Time Expired then just redirecting

        begin

        UniSession.UrlRedirect(AnonymizedLink);

        end;




end;

end;

end.
